using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using EVCB_OCPP.Packet.Utilities;
using EVCB_OCPP.Packet.Messages.SubTypes;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using EVCB_OCPP.Packet.Features;

namespace EVCB_OCPP.Packet.Messages.Core
{
    public class ResetRequest : IRequest
    {
        public ResetRequest()
        {
            Action = Actions.Reset.ToString();
        }

        [JsonIgnore]
        public string Action { set; get; }

        /// <summary>
        /// This contains the type of reset that the
        /// Charge Point should perform.
        /// </summary>
        [Required]
        [JsonConverter(typeof(StringEnumConverter))]
        public ResetType type { set; get; }
        public bool TransactionRelated()
        {
            return false;
        }

        public bool Validate()
        {
            return Validator.TryValidateObject(this, new ValidationContext(this), null, true);
        }
    }
}
